<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Sondage - LeP'titCoindeJol</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<link rel="stylesheet" type="text/css" href="./style.css" />
	
	</head>

<body>

<?php
class Sondage
{
	public $Question = "" ;//Question du sondage
	public $Choix = array() ;//Contient les différents choix possibles du sondage
	public $DejaVote = false;//True si le visiteur a déjà  voté, false (par défaut) sinon
	public $ListeIp = array() ;//Contient l'IP des visiteurs ayant déjà  voté (extrait de $this->FichierIp)
	public $Resultats = array() ;//Contient les résultats des votes (extrait de $this->FichierResultats)
	
	public $FichierIp ;//Adresse du fichier (avec .php pour extension impérativement) contenant les IP des visiteurs ayant déjà  votés (séparées par des ;)
	public $FichierResultats ;//Adresse du fichier (avec .php pour extension impérativement) contenant les résultats du sondage  (séparés par des ; et dans l'ordre de l'array $this->Choix)
		
	//Constructeur de la classe
	public function __construct ( $Question, $Choix, $FichierIp, $FichierResultats )
	{
		$this->Question = $Question ; 
		$this->Choix = $Choix ;
		$this->FichierIp = $FichierIp ;
		$this->FichierResultats = $FichierResultats ;
		
		//Si les fichiers IP et Resultats n'existent pas : les crée (possibilité de supprimer cette partie si vous créez les fichiers manuellement)
		if(!file_exists($FichierIp) OR !file_exists($FichierResultats)) {
			touch($FichierIp) ;
			touch($FichierResultats) ;
		}
		
		//Vérifie si le visiteur a déjà  voté (Vérification Cookie + IP)
		if(isset($_COOKIE['vote']) OR $this->VerifierIp($_SERVER["REMOTE_ADDR"]) === false) {
			$this->DejaVote = true ;
		}
	}
	//Vérifie si l'IP du visiteur est déjà  présente dans dans le fichier $FichierResultats
	private function VerifierIp ($ip)
	{
		$this->ListeIp = explode(";", file_get_contents($this->FichierIp, NULL, NULL, 16));
		if(!empty($this->ListeIp) AND in_array($ip, $this->ListeIp)){
			return false ;
		}
		return true ;
	}
	//Comptabilise le vote du Choix nÂ° $NumVote : A UTILISER AVANT toute sortie (avant les balises <html><head> ...) car utilisation de la fonction setcookie()
	public function AjoutVote ($NumVote)
	{
		if($this->DejaVote === true) {
			return false ;
		}
		$this->Resultats = explode(";", file_get_contents($this->FichierResultats, NULL, NULL, 16));
		//Si premier vote : initialisation de $this->Resultats avec 0 votes pour chaque choix
		if(!isset($this->Resultats[0]{0})) {
			$Nb = sizeof($this->Choix) ;
			for($n=0;$n<$Nb;$n++) $this->Resultats[$n] = '0';
		}
		$this->Resultats[$NumVote]++ ;//Incrémentation du choix pour lequel le visiteur a voté
		
		$this->ListeIp[] = $_SERVER["REMOTE_ADDR"] ;//Ajout de l'IP du votant à  la liste
		
		//Ecriture des Résultats et des IP dans les fichiers
		if( !file_put_contents($this->FichierResultats, '<?php exit(); ?>'.implode(";", $this->Resultats) ) 
		OR !file_put_contents($this->FichierIp, '<?php exit(); ?>'.implode(";", $this->ListeIp) ) ) {
			return false ;
		}
		$this->DejaVote = true ;
		setcookie('vote', true, time()+30*24*60*60) ; //Mise en place d'un cookie valide 1 mois
		return true;
	}
	//Affiche les résultats du vote
	public function AfficherResultats ()
	{
		//Si $this->Resultats est vide : il n'a pas encore été recherché dans le fichier $this->FichierResultats (ou 0 votes : voir ci-dessous)
		if(empty($this->Resultats))
		{
			$this->Resultats = explode(";", file_get_contents($this->FichierResultats, NULL, NULL, 16));
			
			//Si $this->Resultats est toujours vide : 0 votes : initialisation de $this->Resultats
			if(empty($this->Resultats)) {
				$Nb = sizeof($this->Choix) ;
				for($n=0;$n<$Nb;$n++) $this->Resultats[] = 0;
			}
		}
		$TotalVotes = array_sum($this->Resultats) ;//Fait la somme de tous les valeurs de $this->Resultats pour avoir le nombre total de votant
		
		// Affiche Le formulaire de résultats
		echo '<div class="dimension">';
		echo '<div class="contour">';
		echo '<div class="border">'.$this->Question.'</div><table>' ;
		echo '<br>';
		
		//Parcourt l'array $this->Choix afin d'écrire les résultats en utilisant $id pour obtenir le résultat correspondant au choix
		foreach($this->Choix as $id=>$choix)
		{
			@$pourcentage = $this->Resultats[$id]*100/$TotalVotes ;  //Paramétrage du style du formulaire des résultats
			echo '<div class="choix">';
			echo '<tr><td>'.$choix.' : </td><td><img src="bar.gif" height="10" width="'.(2*$pourcentage).'" />  '.number_format($pourcentage, 2, ',', '').' % ('.$this->Resultats[$id].' votes)</td></tr>' ;
			echo '</div>';
		}
		echo '</table><p><b><font face="sans serif" color="1B9230" size="3px" style="margin-left: 10px">Total des votes : </b></font><b> '.$TotalVotes.'</b></p>' ;	// total des votes
		if($this->DejaVote === true) {
			echo '<p><font size="2px" style="margin-left: 10px">Vous avez déjà voté !</font>' ; // Paramétrage style 'vous avez déjà voté' plus 'fermez la fenêtre'
			/* ajoute un lien au visiteur pour laisser un commentaire */
		echo '<div class="post">';
		include ('config.php');
		echo $comment;
		
		echo '</div>';

		}
		else {
			echo '<p><i><a href="?">Retourner au formulaire de vote</a></i></p>';  //retourner au formulaire
			/* ajoute un lien au visiteur pour laisser un commentaire */
		echo '<div class="post">';
		include ('config.php');
		echo $comment;		
		echo '</div>';
		}
		
	}
	/* Affiche le formulaire du vote */
	public function AfficherFormulaire ()
	{
		echo '<div class="contour">';
		echo '<div class="border"><form method="post">'.$this->Question.'</div><table>' ;
		echo '<br>';
		$disable = '';
		if($this->DejaVote === true) {
			$disable = ' disabled="disabled"';//Si le visiteur a déjà  voté : grise le formulaire si nécessaire
			echo '<p>Vous avez déjà voté !</p>' ;
			
						
		}
		foreach($this->Choix as $id=>$choix)
		{
			echo '<tr><td><input type="radio" name="choix" value="'.$id.'"'.$disable.' /></td><td><i><font face="sans serif">'.$choix.'</font></i></td></tr>' ;  // Paramétrage du style du formulaire de vote les choix
		}
		
		
		/*script pour la date de fin du sondage*/
		echo '<div>';
		include ('config.php');
		$cloture = new DateTime($date_cloture);
		$today = new DateTime(date("Y-m-d"));
		$interval = $today->diff($cloture);
		if ($today > $cloture) {
			
		$disable = ' disabled="disabled"'; //vote désactivé
				
		echo '<p>Sondage terminé !</p>' ; // sondage terminé
		
		echo '</table><p><input type="submit" value="Votez!" '.$disable.'/>';
		echo '</p><p><i><a href="?resultats=1">Voir les résultats</a></i></p>';		
		
			
		}
		
		else {
	
		echo '</table><p><input type="submit" value="Votez!" '.$disable.'/>';
		echo '</p><p><i><a href="?resultats=1">Voir les résultats</a></i></p>';
		echo 'Clôture du sondage dans "'.$interval->format('%a').'jour(s)."';
		}

				
		/* ajoute un lien au visiteur pour laisser un commentaire */
		{
		echo '<div class="post">';
		echo $comment;
		
		echo '</div>';
		

		}
		
		
		echo '</div>';
		
		/* fin du script ajouter un lien au visiteur pour laisser un commentaire */
		
		echo '</form></div>';
		
		echo '</div>';
		
		echo '</div>';
		
		
	}
}


?>


</body>
</html>
